package util;

import data.*;

//podemos colocar a varialvel atual(cidade atual) como global.
//nos precisamos da atual pois a lista contm as ids das cidades
//vizinhas  atual.

public class Merge {
	public static void mergeSort(int list[], int p, int r, int atual) {

		if (p < r) {
			int q = (p + r) / 2;
			mergeSort(list, p, q, atual);
			mergeSort(list, q + 1, r, atual);
			merge(list, p, q, r, atual);
		}
	}

	public static void merge(int list[], int p, int q, int r, int atual) {

		int n1 = q - p + 1;
		int n2 = r - q;

		int i, j;

		int l1[] = new int[n1];
		int l2[] = new int[n2];

		for (i = 0; i < n1; i++) { // O(n)
			l1[i] = list[p + i];
		}
		for (i = 0; i < n2; i++)
			l2[i] = list[q + i + 1];

		int k = p;
		i = j = 0;

		Data d = Data.getPRVData();
		while ((i < n1) && (j < n2)) {

			if (d.getDistancia(atual, l1[i]) < d.getDistancia(atual, l2[j])) {
				list[k] = l1[i];
				i++;
				k++;
			} else {
				list[k] = l2[j];
				j++;
				k++;
			}
		}
		while (i < n1) {
			list[k] = l1[i];
			i++;
			k++;
		}
		while (j < n2) {
			list[k] = l2[j];
			j++;
			k++;
		}

	}
}
